﻿;basic loader creator v4.0 (tr-dos/tape editions) for Alasm 5.x only!
;© 2010-2011, 2013 all rights reserved by faster/hlm
;выражаю благодарность за некоторые идеи: Goodboy, Char, ZS.

LoaderVersion	EQU	1				;0/1 - формат бейсик-строки в бейсик-программе
							;0 - RUN USR X (для TR-DOS)
							;1 - RUN USR VAL "PEEK 23628*256+PEEK 23627" (для TR-DOS/TAPE)
CopyrightLine	EQU	1				;0/1 - не использовать/использовать текст сообщения в бейсик-строке
MessageLine	EQU	1				;0/1 - не использовать/использовать пространство до конца сектора
HiddenLine	EQU	0				;0/1 - не скрывать/скрывать отображение команды RUN USR ...
;-
NumberLine	EQU	0				;номер бейсик-строки (от 16384-65535 - защита от команды MERGE "")
StartLine	EQU	NumberLine			;номер строки автостарта

		ORG	#5CDD				;системная переменная TR-DOS - имя файла в ASCII, тип файла
		DB	"BLC v4.0","B"			;имя файла с расширением "B"

		MACRO	Variable			;символ для RUN USR
VarSymbol	EQU	"X"
		DB	VarSymbol
		ENDM
		
		MACRO	CopyrightText			;текст сообщения в бейсик-строке
		DB	AT,0,0				;адрес вывода сообщения на экран
		DB	BRIGHT,1,PAPER,0,INK,4
		DB   "    Basic Loader Creator 4.0    " ;первая строка
		DB	INK,6
		DB   "  (c) 05.07.2013 by Faster/HLM  " ;вторая строка
		ENDM

		MACRO	UnusedSpace			;свободное пространство до конца сектора (UNUSED SPACE)
		DB   ":: (c) 2010-2011, 2013 Basic Loa" ;строка 64 байта, но размер зависит от свободного места -
		DB   "der Creator 4.0 by Faster/HLM ::"	;надо после первого прохода ассемблера проверять!
		ENDM

		MACRO	CodeLoader			;код загрузчика
		LOCAL					;локальные метки
		LD	A,(PROG)			;проверяем запущена ли программа в TR-DOS
		CP	#3B
		JR	Z,TrDos				;запущена в TR-DOS
		...	...				;запущена не в TR-DOS, например в TAPE
		ENDL
		ENDM
;-
BACKSPACE	EQU	#08				;управляющие коды для использования в бейсик-программе
INK		EQU	#10
PAPER		EQU	#11
FLASH		EQU	#12
BRIGHT		EQU	#13
INVERSE		EQU	#14
OVER		EQU	#15
AT		EQU	#16
TAB		EQU	#17
;-
VARS		EQU	#5C4B				;адрес начала области переменных бейсик-программы
PROG		EQU	#5C53				;адрес начала бейсик-программы
E_LINE		EQU	#5C59				;адрес начала редактируемой строки
;-
		ORG	VARS
		DW	BasicLineEnd
		ORG	#5CE8
		DW	LengthLine			;длина для LENGTH

		ORG	#8000
		LD	HL,BasicLine
		LD	DE,Length			;длина для START
		SCF
		ADC	HL,DE
		LD	(E_LINE),HL
		LD	HL,BasicStart			;начало бейсик-программы
		LD	C,#B				;код функции записи файла
		CALL	#3D13
		RET
;-
BasicStart	DISP	#5D3B				;начало бейсик-программы (#5D3B - для TR-DOS, #5CCB - для +3DOS и TAPE)

BasicLine	DB	'NumberLine,.NumberLine		;2 байта номера бейсик-строки
		DW	BasicLineEnd-BasicLoader	;2 байта длины бейсик-строки

BasicLoader	DD	F7C0				;RUN USR
		IF0	LoaderVersion
		Variable				;то, что отображается после USR
		HiddenSymbols=11			;количество скрываемых символов
		ELSE
		DD	B022BE32333632382A		;VAL "PEEK 23628*
		IFN	HiddenLine
		HiddenSymbols=26
		DUP	HiddenSymbols
		DB	BACKSPACE
		EDUP
		DUP	HiddenSymbols+3			;+3 байта, для переноса числа 256 на другую строку
		DB	" "				;скрываем первую часть бейсик-строки
		EDUP
		ENDIF
		DD	3235362BBE323336323722		;256+PEEK 23627"
		HiddenSymbols=15			;количество скрываемых символов для второй части бейсик-строки
		ENDIF
		IFN	HiddenLine
		DUP	HiddenSymbols
		DB	BACKSPACE			;скрываем RUN USR ...
		EDUP
		DUP	HiddenSymbols
		DB	" "				;пробелами
		EDUP
		ENDIF
		IFN	CopyrightLine
		IF0	LoaderVersion
		DD	3A0820				;отделяем команду символом ":" и скрываем символ
		ENDIF
		CopyrightText
		ENDIF
		DD	10FF				;вводим ошибочное значение, чтобы скрыть дальнейшее отображение бейсик-строки
		DB	#D				;конец бейсик-строки

BasicLineEnd	IF0	LoaderVersion			;область бейсик-переменных
		DB	VarSymbol+#20			;имя переменной переводим в нижний регистр
		DB	0,0,.Code,'Code,0		;пять байт цифрового значения
		ENDIF
;-
Code		CodeLoader				;размещаем код в области бейсик-переменных
;-		
BasicFileEnd	DD	80AA				;конец бейсик-файла
		DW	StartLine			;2 байта номера строки автостарта
;-
		IFN	MessageLine
		UnusedSpace	
		ENDIF		
		DS	#100				;заполняем 0 до конца сектора, чтобы не было мусора
;-
		LengthLine=BasicLineEnd-BasicLine
		Length=BasicFileEnd-BasicLine
		LengthSec=.Length/#100+#1

		DISPLAY
		DISPLAY	"Длина бейсик-строки:",/A,LengthLine," байт(а/ов)"
		DISPLAY	"Длина кода:",/A,BasicFileEnd-Code," байт(а/ов)"
		DISPLAY	"Длина бейсик-Файла:",/A,Length," байт(а/ов),",/A,LengthSec," сектор(а/ов)"
		DISPLAY	"Свободное место до конца сектора:",/A,LengthSec*#100-Length," байт(а/ов)"